print "INIT ",pc
	LDA #$02
	STA $1504,x
	RTL

print "MAIN ",pc
	PHB : PHK : PLB
		JSR Main
	PLB : RTL
	
Main:
	LDY #$00
	JSR SubOffScreen
	
	LDA $14
	AND #$03
	BNE +
	LDA $C2,x
	BEQ +
	INC $1504,x
	LDA $1504,x
	CMP #$06
	BCC +
	LDA #$02
	STA $1504,x
+	JSR GFX
	
	JSL $018022	; Update sprite x position without gravity
	JSL $01801A	; Update sprite y position without gravity
	
	JSL $019138	; Sprite <-> Object interaction
	
	JSR HandleSpriteStuff
	
	LDA $1588,x
	BEQ .nokill
	JSR Smoke
	STZ $14C8,x
.nokill
	RTS
	
HandleSpriteStuff:
	JSL $03B69F		; sprite clipping A
	LDY #$0B
.loop
	CPY $15E9
	BEQ .next
	LDA $14C8,y
	CMP #$08
	BCS .found
.next
	DEY : BPL .loop
	RTS
.found
	TYX
	JSL $03B6E5		; sprite clipping B
	LDX $15E9
	JSL $03B72B		; check for contact
	BCC .next
	
	TYX
	PHY
	JSR Smoke
	PLY
	
	STZ $14C8,x
	LDX $15E9
	
	LDA $C2,x
	BNE .next
	STZ $14C8,x
	RTS

Smoke:
	LDY #$03
-
	LDA $17C0,y
	BEQ +
	DEY
	BPL -
	RTS
+
	LDA #$01
	STA $17C0,y
	LDA #$1C     
	STA $17CC,y
	LDA $D8,x
	STA $17C4,y
	LDA $E4,x
	STA $17C8,y
	RTS

GFX:
	JSR GetDrawInfo
	LDA $00
	STA $0300,y
	LDA $01
	STA $0301,y
	LDA #$C2
	STA $0302,y
	LDA $1504,x
	ASL
	AND #$0E
	STA $0303,y
	
	LDA #$00
	LDY #$02
	JSL $01B7B3
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$20
		SEC
		SBC $1A
		STA $00
		CLC
		ADC.w #$0040
		CMP.w #$0180
		SEP #$20
		LDA $01
		BEQ +
		LDA #$01
+		STA $15A0,x
		TDC
		ROL A
		STA $15C4,x
		BNE .Invalid

		LDA $14D4,x
		XBA
		LDA $1662,x
		AND #$20
		BEQ .CheckOnce
.CheckTwice
		LDA $D8,x
		REP #$21
		ADC.w #$001C
		SEC
		SBC $1C
		SEP #$20
		LDA $14D4,x
		XBA
		BEQ .CheckOnce
		LDA #$02
.CheckOnce
		STA $186C,x
		LDA $D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$21
		SBC #$0C
		STA $01
		XBA
		BEQ .OnScreenY
		INC $186C,x
.OnScreenY
		LDY $15EA,x
		RTS
		
.Invalid
		PLA
		PLA
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreen:	LDA $15A0,x
		ORA $186C,x
		BEQ .Return2
		LDA $167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA $D8,x
		ADC #$50
		LDA $14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA $14C8,x
		CMP #$08
		BCC .KillSprite
		LDY $161A,x
		CPY #$FF
		BEQ .KillSprite
		LDA $1938,y
		AND #$FE
		STA $1938,y
.KillSprite	STZ $14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160